diff --git a/lib/app/modules/petugas_desa/views/detail_pengaduan_view.dart b/lib/app/modules/petugas_desa/views/detail_pengaduan_view.dart
index dbb9585..bd43001 100644
--- a/lib/app/modules/petugas_desa/views/detail_pengaduan_view.dart
+++ b/lib/app/modules/petugas_desa/views/detail_pengaduan_view.dart
@@ -2048,128 +1564,321 @@ class DetailPengaduanView extends GetView<PengaduanController> {
                         Row(
                           children: [
                             Icon(
-                              Icons.comment,
-                              color: Colors.amber.shade800,
+                              Icons.info_outline,
+                              color: Colors.blue.shade800,
                               size: 18,
                             ),
                             const SizedBox(width: 8),
                             Text(
-                              'Feedback dari Warga',
+                              'Informasi',
                               style: TextStyle(
                                 fontWeight: FontWeight.bold,
                                 fontSize: 14,
-                                color: Colors.amber.shade800,
+                                color: Colors.blue.shade800,
                               ),
                             ),
                           ],
                         ),
                         const SizedBox(height: 8),
-                        if (tindakan.ratingWarga != null) ...[
-                          Row(
-                            children: [
-                              Text(
-                                'Rating: ',
-                                style: TextStyle(
-                                  fontSize: 12,
-                                  color: Colors.amber.shade800,
-                                ),
-                              ),
-                              Row(
-                                children: List.generate(5, (index) {
-                                  return Icon(
-                                    index < (tindakan.ratingWarga ?? 0)
-                                        ? Icons.star
-                                        : Icons.star_border,
-                                    color: Colors.amber,
-                                    size: 16,
-                                  );
-                                }),
-                              ),
-                            ],
-                          ),
-                          const SizedBox(height: 4),
-                        ],
                         Text(
-                          tindakan.feedbackWarga!,
+                          'Dengan mengirimkan form ini, status tindakan akan berubah menjadi SELESAI dan tidak dapat diubah kembali.',
                           style: TextStyle(
-                            fontSize: 13,
-                            color: Colors.amber.shade900,
-                            fontStyle: FontStyle.italic,
+                            fontSize: 12,
+                            color: Colors.blue.shade700,
                           ),
                         ),
                       ],
                     ),
                   ),
+                  TextInput(
+                    label: 'Hasil Tindakan',
+                    hint: 'Jelaskan hasil dari tindakan yang dilakukan',
+                    controller: hasilTindakanController,
+                    maxLines: 3,
+                    required: true,
+                    validator: (value) {
+                      if (value == null || value.isEmpty) {
+                        return 'Hasil tindakan wajib diisi';
+                      }
+                      return null;
+                    },
+                  ),
+                  const SizedBox(height: 8),
+                  TextInput(
+                    label: 'Catatan',
+                    hint: 'Tambahkan catatan jika diperlukan',
+                    controller: catatanController,
+                    maxLines: 2,
+                  ),
+                  const SizedBox(height: 8),
+                  // Bukti tindakan - wajib
+                  Column(
+                    crossAxisAlignment: CrossAxisAlignment.start,
+                    children: [
+                      Row(
+                        children: [
+                          Text(
+                            'Bukti Tindakan',
+                            style: Theme.of(context).textTheme.titleSmall,
+                          ),
+                        ],
+                      ),
+                      const SizedBox(height: 8),
+                      Container(
+                        padding: const EdgeInsets.all(12),
+                        decoration: BoxDecoration(
+                          color: Colors.grey.shade100,
+                          borderRadius: BorderRadius.circular(8),
+                          border: Border.all(color: Colors.grey.shade300),
+                        ),
+                        child: Column(
+                          crossAxisAlignment: CrossAxisAlignment.start,
+                          children: [
+                            if (buktiTindakanPaths.isEmpty)
+                              InkWell(
+                                onTap: () => showPilihSumberFoto(stateContext),
+                                child: Container(
+                                  height: 150,
+                                  width: double.infinity,
+                                  decoration: BoxDecoration(
+                                    color: Colors.grey.shade200,
+                                    borderRadius: BorderRadius.circular(8),
+                                    border:
+                                        Border.all(color: Colors.grey.shade400),
+                                  ),
+                                  child: Column(
+                                    mainAxisAlignment: MainAxisAlignment.center,
+                                    children: [
+                                      Icon(
+                                        Icons.camera_alt,
+                                        size: 48,
+                                        color: Colors.grey.shade600,
+                                      ),
+                                      const SizedBox(height: 8),
+                                      Text(
+                                        'Tambah Bukti Tindakan',
+                                        style: TextStyle(
+                                          color: Colors.grey.shade600,
+                                          fontWeight: FontWeight.bold,
+                                        ),
+                                      ),
+                                    ],
+                                  ),
+                                ),
+                              )
+                            else
+                              Column(
+                                crossAxisAlignment: CrossAxisAlignment.start,
+                                children: [
+                                  SizedBox(
+                                    height: 100,
+                                    child: ListView.builder(
+                                      scrollDirection: Axis.horizontal,
+                                      itemCount: buktiTindakanPaths
+                                          .length, //tombol tambah jika tidak selesai
+                                      itemBuilder: (context, index) {
+                                        if (index ==
+                                            buktiTindakanPaths.length) {
+                                          // Tombol tambah foto
+                                          return InkWell(
+                                            onTap: () => showPilihSumberFoto(
+                                                stateContext),
+                                            child: Container(
+                                              width: 100,
+                                              margin: const EdgeInsets.only(
+                                                  right: 8),
+                                              decoration: BoxDecoration(
+                                                color: Colors.grey.shade200,
+                                                borderRadius:
+                                                    BorderRadius.circular(8),
+                                                border: Border.all(
+                                                    color:
+                                                        Colors.grey.shade400),
+                                              ),
+                                              child: Column(
+                                                mainAxisAlignment:
+                                                    MainAxisAlignment.center,
+                                                children: [
+                                                  Icon(
+                                                    Icons.add_photo_alternate,
+                                                    size: 32,
+                                                    color: Colors.grey.shade600,
+                                                  ),
+                                                  const SizedBox(height: 4),
+                                                  Text(
+                                                    'Tambah',
+                                                    style: TextStyle(
+                                                      color:
+                                                          Colors.grey.shade600,
+                                                      fontSize: 12,
+                                                    ),
+                                                  ),
+                                                ],
+                                              ),
+                                            ),
+                                          );
+                                        }
+
+                                        // Tampilkan foto yang sudah diambil
+                                        return Stack(
+                                          children: [
+                                            GestureDetector(
+                                              onTap: () => showFullScreenImage(
+                                                  stateContext,
+                                                  buktiTindakanPaths[index]),
+                                              child: Container(
+                                                width: 100,
+                                                height: 100,
+                                                margin: const EdgeInsets.only(
+                                                    right: 8),
+                                                decoration: BoxDecoration(
+                                                  borderRadius:
+                                                      BorderRadius.circular(8),
+                                                  image: DecorationImage(
+                                                    image: buktiTindakanPaths[
+                                                                index]
+                                                            .startsWith('http')
+                                                        ? NetworkImage(
+                                                            buktiTindakanPaths[
+                                                                index])
+                                                        : FileImage(File(
+                                                                buktiTindakanPaths[
+                                                                    index]))
+                                                            as ImageProvider,
+                                                    fit: BoxFit.cover,
+                                                  ),
+                                                ),
+                                              ),
+                                            ),
+                                            Positioned(
+                                              top: 4,
+                                              right: 12,
+                                              child: GestureDetector(
+                                                onTap: () {
+                                                  setState(() {
+                                                    buktiTindakanPaths
+                                                        .removeAt(index);
+                                                  });
+                                                },
+                                                child: Container(
+                                                  padding:
+                                                      const EdgeInsets.all(4),
+                                                  decoration: BoxDecoration(
+                                                    color: Colors.black
+                                                        .withOpacity(0.5),
+                                                    shape: BoxShape.circle,
+                                                  ),
+                                                  child: const Icon(
+                                                    Icons.close,
+                                                    color: Colors.white,
+                                                    size: 16,
+                                                  ),
+                                                ),
+                                              ),
+                                            ),
+                                          ],
+                                        );
+                                      },
+                                    ),
+                                  ),
+                                ],
+                              ),
+                          ],
+                        ),
+                      ),
+                    ],
+                  ),
                 ],
-              ],
+              ),
             ),
           ),
-        ),
-        actions: [
-          TextButton(
-            onPressed: () => Navigator.pop(context),
-            child: const Text('Batal'),
-          ),
-          ElevatedButton(
-            onPressed: () async {
-              if (formKey.currentState!.validate()) {
-                try {
-                  // Buat data update
-                  final Map<String, dynamic> updateData = {
-                    'tindakan': tindakanController.text,
-                    'catatan': catatanController.text,
-                    'hasil_tindakan': hasilTindakanController.text,
-                    'status_tindakan': selectedStatus,
-                    'prioritas': selectedPrioritas,
-                    'kategori_tindakan': selectedKategori,
-                    'bukti_tindakan': buktiTindakanList.toList(),
-                    'updated_at': DateTime.now().toIso8601String(),
-                  };
-
-                  // Jika status berubah menjadi SELESAI, tambahkan tanggal verifikasi
-                  if (selectedStatus == 'SELESAI' &&
-                      tindakan.statusTindakan != 'SELESAI') {
-                    updateData['tanggal_verifikasi'] =
-                        DateTime.now().toIso8601String();
-                  }
-
-                  // Update tindakan
-                  await SupabaseService.to
-                      .updateTindakanPengaduan(tindakan.id!, updateData);
-
-                  // Tutup dialog
-                  Navigator.pop(context);
-
-                  // Refresh halaman
-                  Get.forceAppUpdate();
-
-                  // Tampilkan snackbar
-                  Get.snackbar(
-                    'Berhasil',
-                    'Tindakan berhasil diperbarui',
-                    snackPosition: SnackPosition.TOP,
-                    backgroundColor: Colors.green,
-                    colorText: Colors.white,
-                  );
-                } catch (e) {
-                  print('Error updating tindakan: $e');
-                  Get.snackbar(
-                    'Error',
-                    'Gagal memperbarui tindakan: ${e.toString()}',
-                    snackPosition: SnackPosition.TOP,
-                    backgroundColor: Colors.red,
-                    colorText: Colors.white,
-                  );
-                }
-              }
-            },
-            style: ElevatedButton.styleFrom(
-              backgroundColor: Colors.green,
+          actions: [
+            TextButton(
+              onPressed: () => Navigator.pop(dialogContext),
+              child: const Text('Batal'),
             ),
-            child: const Text('Simpan Perubahan'),
-          ),
-        ],
-      ),
+            ElevatedButton(
+              onPressed: controller.isUploading.value
+                  ? null
+                  : () async {
+                      if (formKey.currentState!.validate()) {
+                        // Validasi bukti tindakan
+                        if (buktiTindakanPaths.isEmpty) {
+                          Get.snackbar(
+                            'Error',
+                            'Bukti tindakan wajib diisi',
+                            snackPosition: SnackPosition.TOP,
+                            backgroundColor: Colors.red,
+                            colorText: Colors.white,
+                          );
+                          return;
+                        }
+
+                        try {
+                          Navigator.pop(dialogContext); // Tutup dialog form
+
+                          // Tampilkan loading dialog
+                          showDialog(
+                            context: context,
+                            barrierDismissible: false,
+                            builder: (BuildContext context) {
+                              return const Center(
+                                child: CircularProgressIndicator(),
+                              );
+                            },
+                          );
+
+                          // Panggil fungsi update tindakan dengan upload file
+                          await controller.updateTindakanPengaduan(
+                            tindakanId: tindakan.id!,
+                            pengaduanId: tindakan.pengaduanId!,
+                            tindakan: tindakan
+                                .tindakan!, // Gunakan tindakan yang sudah ada
+                            kategoriTindakan: selectedKategori ??
+                                '', // Gunakan kategori yang sudah ada
+                            statusTindakan: selectedStatus,
+                            prioritas: selectedPrioritas ??
+                                '', // Gunakan prioritas yang sudah ada
+                            catatan: catatanController.text.isEmpty
+                                ? null
+                                : catatanController.text,
+                            hasilTindakan: hasilTindakanController.text.isEmpty
+                                ? null
+                                : hasilTindakanController.text,
+                            buktiTindakanPaths: buktiTindakanPaths,
+                          );
+                        } catch (e) {
+                          // Tutup loading dialog jika terjadi error
+                          Navigator.of(context, rootNavigator: true).pop();
+
+                          print('Error updating tindakan: $e');
+                          Get.snackbar(
+                            'Error',
+                            'Gagal memperbarui tindakan: ${e.toString()}',
+                            snackPosition: SnackPosition.TOP,
+                            backgroundColor: Colors.red,
+                            colorText: Colors.white,
+                          );
+                        }
+                      }
+                    },
+              style: ElevatedButton.styleFrom(
+                backgroundColor: AppTheme.primaryColor,
+              ),
+              child: controller.isUploading.value
+                  ? const SizedBox(
+                      width: 20,
+                      height: 20,
+                      child: CircularProgressIndicator(
+                        strokeWidth: 2,
+                        color: Colors.white,
+                      ),
+                    )
+                  : const Text('Simpan Perubahan'),
+            ),
+          ],
+        );
+      }),
     );
   }
 
@@ -2212,7 +1921,9 @@ class DetailPengaduanView extends GetView<PengaduanController> {
               ),
             ),
             const SizedBox(height: 8),
-            ...statusOptions.map((status) => RadioListTile<String>(
+            Column(
+              children: statusOptions.map((status) {
+                return RadioListTile<String>(
                   title: Text(
                     status == 'MENUNGGU'
                         ? 'Menunggu'
@@ -2239,7 +1950,9 @@ class DetailPengaduanView extends GetView<PengaduanController> {
                         ? Colors.orange
                         : (status == 'TINDAKAN' ? Colors.blue : Colors.green),
                   ),
-                )),
+                );
+              }).toList(),
+            ),
           ],
         ),
         actions: [
@@ -2345,4 +2058,138 @@ class DetailPengaduanView extends GetView<PengaduanController> {
       ),
     );
   }
+
+  void showFullScreenImage(BuildContext context, String imageUrl) {
+    // Buat controller untuk InteractiveViewer
+    final TransformationController transformationController =
+        TransformationController();
+
+    Get.dialog(
+      Dialog(
+        insetPadding: EdgeInsets.zero,
+        child: Stack(
+          fit: StackFit.expand,
+          children: [
+            InteractiveViewer(
+              panEnabled: true,
+              minScale: 0.5,
+              maxScale: 4,
+              transformationController: transformationController,
+              child: imageUrl.startsWith('http')
+                  ? Image.network(
+                      imageUrl,
+                      fit: BoxFit.contain,
+                      loadingBuilder: (context, child, loadingProgress) {
+                        if (loadingProgress == null) return child;
+                        return Center(
+                          child: CircularProgressIndicator(
+                            value: loadingProgress.expectedTotalBytes != null
+                                ? loadingProgress.cumulativeBytesLoaded /
+                                    loadingProgress.expectedTotalBytes!
+                                : null,
+                          ),
+                        );
+                      },
+                      errorBuilder: (context, error, stackTrace) {
+                        return Container(
+                          color: Colors.grey.shade300,
+                          child: const Center(
+                            child: Icon(
+                              Icons.error,
+                              size: 50,
+                              color: Colors.red,
+                            ),
+                          ),
+                        );
+                      },
+                    )
+                  : Image.file(
+                      File(imageUrl),
+                      fit: BoxFit.contain,
+                      errorBuilder: (context, error, stackTrace) {
+                        return Container(
+                          color: Colors.grey.shade300,
+                          child: const Center(
+                            child: Icon(
+                              Icons.error,
+                              size: 50,
+                              color: Colors.red,
+                            ),
+                          ),
+                        );
+                      },
+                    ),
+            ),
+            Positioned(
+              top: 20,
+              right: 20,
+              child: GestureDetector(
+                onTap: () => Get.back(),
+                child: Container(
+                  padding: const EdgeInsets.all(8),
+                  decoration: BoxDecoration(
+                    color: Colors.black.withOpacity(0.5),
+                    shape: BoxShape.circle,
+                  ),
+                  child: const Icon(
+                    Icons.close,
+                    color: Colors.white,
+                  ),
+                ),
+              ),
+            ),
+            Positioned(
+              bottom: 20,
+              right: 20,
+              child: Row(
+                children: [
+                  GestureDetector(
+                    onTap: () {
+                      // Zoom in
+                      final Matrix4 matrix =
+                          transformationController.value.clone();
+                      matrix.scale(1.5);
+                      transformationController.value = matrix;
+                    },
+                    child: Container(
+                      padding: const EdgeInsets.all(8),
+                      decoration: BoxDecoration(
+                        color: Colors.black.withOpacity(0.5),
+                        shape: BoxShape.circle,
+                      ),
+                      child: const Icon(
+                        Icons.zoom_in,
+                        color: Colors.white,
+                      ),
+                    ),
+                  ),
+                  const SizedBox(width: 8),
+                  GestureDetector(
+                    onTap: () {
+                      // Zoom out
+                      final Matrix4 matrix =
+                          transformationController.value.clone();
+                      matrix.scale(0.75);
+                      transformationController.value = matrix;
+                    },
+                    child: Container(
+                      padding: const EdgeInsets.all(8),
+                      decoration: BoxDecoration(
+                        color: Colors.black.withOpacity(0.5),
+                        shape: BoxShape.circle,
+                      ),
+                      child: const Icon(
+                        Icons.zoom_out,
+                        color: Colors.white,
+                      ),
+                    ),
+                  ),
+                ],
+              ),
+            ),
+          ],
+        ),
+      ),
+    );
+  }
 }
diff --git a/lib/app/modules/petugas_desa/views/pengaduan_view.dart b/lib/app/modules/petugas_desa/views/pengaduan_view.dart
index 2b2a5e4..879a5b1 100644
--- a/lib/app/modules/petugas_desa/views/pengaduan_view.dart
+++ b/lib/app/modules/petugas_desa/views/pengaduan_view.dart
@@ -593,7 +593,20 @@ class PengaduanView extends GetView<PengaduanController> {
           ),
           ElevatedButton(
             onPressed: () {
-              controller.tambahTindakan(item.id!);
+              if (controller.tindakanFormKey.currentState!.validate()) {
+                Navigator.pop(context);
+                controller.tambahTindakanPengaduan(
+                  pengaduanId: item.id!,
+                  tindakan: controller.tindakanController.text,
+                  kategoriTindakan: 'VERIFIKASI_DATA',
+                  statusTindakan: 'PROSES',
+                  prioritas: 'SEDANG',
+                  catatan: controller.catatanController.text.isEmpty
+                      ? null
+                      : controller.catatanController.text,
+                  buktiTindakanPaths: [],
+                );
+              }
             },
             child: const Text('Simpan'),
           ),
